// KURUMA Keizo:2011. thank you for your attention.
// 何かの役に立つなら "modified BSD license" か "X11 license" でご自由にどうぞ

function Clone(dst, src)
{
	for( m in src )
		dst[m] = src[m];
}

var qt = 16; //クオンタイズっていうかスクリーン座標変換の係数
var screen_w = 512;
var screen_h = 400;
var box_wh = 30;

var keyst =
{
	l:false
	,r:false
	,u:false
	,d:false
	,b1:false
	,b2:false
	,b3:false
	,b4:false
}


///////////////////////

var actor =
{
	status:0 //0:生きてる 1:死んだ
	, color1:null
	, color2:null
	, x:screen_w/2*qt, y:screen_h/2*qt
	, vx:0, vy:0
	, xmin:box_wh/2 * qt
	, xmax:(screen_w-box_wh/2) * qt
	, ymin:box_wh/2 * qt
	, ymax:(screen_h-box_wh/2) * qt

	, //再初期化
	reinit:function() {
		this.status = 0;
		this.x = screen_w/2*qt;
		this.y = screen_h/2*qt;
		this.vx = 0;
		this.vy = 0;
	}

	, //やられた
	die:function() {
		this.status = 1;
		//model.stop();
	}

	, //キャラ移動
	move:function() {

		//キーに応じてキャラ移動
		ix = 0;
		iy = 0;

		d = 1/2 * qt;

		vmax = 5 * qt
		eps = 1;

		//動く意図
		if( this.status == 0 ) {
			if( keyst.l ) ix -= d;
			if( keyst.r ) ix += d;
			if( keyst.u ) iy -= d;
			if( keyst.d ) iy += d;

			//斜めの場合、力をsin(45)化
			if( ix != 0 && iy != 0 ) {
				ix = Math.floor(ix * .85);
				iy = Math.floor(iy * .85);
			}
		}

		//XY どちらかへ進む
		this.vx += ix;
		this.vy += iy;

		//X速度上限
		if(-eps < this.vx && this.vx < eps) this.vx = 0;
		else if( this.vx < -vmax ) this.vx = -vmax;
		else if( vmax < this.vx  ) this.vx = vmax;

		//Y速度上限
		if(-eps < this.vy && this.vy < eps) this.vy = 0;
		else if( this.vy < -vmax ) this.vy = -vmax;
		else if( vmax < this.vy  ) this.vy = vmax;

		// 斜めの場合...
		//if( this.vx != 0 && this.vy != 0 ) {
		//  this.vx *= .85;
		//  this.vy *= .85;
		//}


		//位置変更
		this.x += this.vx;
		this.y += this.vy;

		//位置上限下限X
		if     ( this.x < this.xmin ) {this.x = this.xmin; this.vx = 0;}
		else if( this.xmax < this.x ) {this.x = this.xmax; this.vx = 0;}

		//位置上限下限Y
		if     ( this.y < this.ymin ) {this.y = this.ymin; this.vy = 0;}
		else if( this.ymax < this.y ) {this.y = this.ymax; this.vy = 0;}
	}
}


function Enemy(id_)
{
	Clone(this, Enemy_proto);
	this.id = id_;
}
var Enemy_proto =
{
	id:0
	, status:0 //0:生きてる 1:死んだ
	, color1:null, color2:null
	, x:0, y:0
	, vx:0, vy:0
	, ix:0, iy:0
	, dx:1*qt, dy:1*qt //...
	, xmin:box_wh/2 * qt
	, xmax:(screen_w-box_wh/2) * qt
	, ymin:box_wh/2 * qt
	, ymax:(screen_h-box_wh/2) * qt
	
	, //再初期化
	reinit:function() {
		this.status = 0;
		this.x = (screen_w-box_wh)*qt;
		this.y = (screen_h-box_wh)*qt;
		this.vx = 0;
		this.vy = 0;
	}

	, //死んだ
	die:function() {
		this.status = 1;
		//model.stop();
	}

	, //移動
	move:function() {
		if( this.status != 0 ) return;

		//
		this.vx = this.vy = 0;
		if     ( this.x < actor.x ) this.vx = this.dx
		else if( actor.x < this.x ) this.vx = -this.dx;
		if     ( this.y < actor.y ) this.vy = this.dy;
		else if( actor.y < this.y ) this.vy = -this.dy;

		//
		this.x += this.vx;
		this.y += this.vy;

		//位置上限下限XY
		if     ( this.x < this.xmin ) this.x = this.xmin;
		else if( this.xmax < this.x ) this.x = this.xmax;
		if     ( this.y < this.ymin ) this.y = this.ymin;
		else if( this.ymax < this.y ) this.y = this.ymax;

	}
}

var model =
{
	score:0
	,result:0 //0:通常 1:プレイヤー負け 2:プレイヤー勝ち
	,timerid:null
	,enemy_cnt:0 //生きてる敵の数
	,enemy_max:4
	,enemies:null

	, //初期化
	init:function() {
		this.enemies = new Array(this.enemy_max);
		for( i = 0; i < this.enemy_max; i++ ) {
			this.enemies[i] = new Enemy(i);
		}

		model.enemies[0].dx = 2*qt;
		model.enemies[0].dy = 4*qt;
		
		model.enemies[1].dx = 4*qt;
		model.enemies[1].dy = 2*qt;

		if( 2 < model.enemy_max ) {
			model.enemies[2].dx = 1*qt;
			model.enemies[2].dy = 3*qt;
			
			model.enemies[3].dx = 3*qt;
			model.enemies[3].dy = 1*qt;
		}

		this.reinit();
	}

	,
	reinit:function() {
		this.score = 0;
		this.result = 0;
		this.enemy_cnt = this.enemy_max;

		actor.reinit();

		for( i = 0; i < this.enemy_max; i++ ) {
			this.enemies[i].reinit();
		}

		model.enemies[0].x = box_wh/2*qt;
		model.enemies[0].y = box_wh/2*qt;

		model.enemies[1].x = (screen_w-box_wh/2)*qt;
		model.enemies[1].y = (screen_h-box_wh/2)*qt;

		if( 2 < model.enemy_max ) {
			model.enemies[2].x = box_wh/2*qt;
			model.enemies[2].y = (screen_h-box_wh/2)*qt;

			model.enemies[3].x = (screen_w-box_wh/2)*qt;
			model.enemies[3].y = box_wh/2*qt;
		}
	}

	, //移動
	move:function() {

		actor.move();

		for( i = 0; i < this.enemy_max; i++ ) {
			if( this.enemies[i].status == 0 )
				this.enemies[i].move();
		}

		this.score++;

		this.colicheck();
	}

	, //衝突チェック
	colicheck:function() {
		try {
			d = 10*qt;
			d2 = 10*qt;

			//全enemies
			for( i = 0; i < this.enemy_max; i++ ) {
				
				//既に死んでる敵はスキップ
				if( this.enemies[i].status != 0 ) {
					continue;
				}

				//actorと位置が近い
				if( Math.abs(this.enemies[i].x - actor.x) < d
					&& Math.abs(this.enemies[i].y - actor.y) < d ) {

					if( ! keyst.b3 ) {
						this.result = 1;
						actor.die();
						this.score = Math.floor(this.score/4);
					}
					view.debug.value = "hit";
					//model.stop();
				}

				//enemy同士
				for( j = i+1; j < this.enemy_max; j++ ) {

					//既に死んでる敵はスキップ
					if( this.enemies[j].status != 0 ) {
						continue;
					}

					//位置が近い
					if( Math.abs(this.enemies[i].x - this.enemies[j].x) < d2
						&& Math.abs(this.enemies[i].y - this.enemies[j].y) < d2 ) {

						this.enemies[i].die();
						this.enemies[j].die();
						this.enemy_cnt -= 2;
						this.score *= 2;
					}
					view.debug.value = this.enemy_cnt;
					if( this.enemy_cnt <= 0 ) {
						this.result = 2;

						//model.stop();
					}
				}
			}
		} catch(ex) {
			model.stop();
			alert(ex);
		}
	}

	,
	start:function()
	{
		if( this.timerid == null ) {
			if( model.result == 0 ) {
				this.timerid = setInterval(this.onTimer, 17); // about 1 inter
				//this.timerid = setInterval(this.onTimer, 34); // about 2 inter
				return;
			}
			this.timerid = setInterval(this.onTimer, 34); // 2 inter
		}
	}

	,
	stop:function()
	{
		clearTimeout(this.timerid);
		this.timerid = null;
	}

	,
	onTimer:function()
	{
		//view.debug.value = "" + view.debug.value + "|";

		// 結果表示とリスタート
		if( model.result != 0 ) {
			model.stop();
			model.start();

			view.drawResult();

			if( keyst.b4 ) {
				btnRestartOnClick();
			}
			return;
		}

		//移動
		model.move();

		//描画
		view.draw();
	}
}

////////////////////////

var view =
{
	canvas:null
	,context:null

	,score:null
	,debug:null

	,
	init:function() {
		this.canvas = document.getElementById("canvas0");
		this.context = this.canvas.getContext("2d");

		this.score = document.getElementById("score");
		this.debug = document.getElementById("debug");

		//先にmodelがinitされていることが必要
		actor.color1 = "rgb(0,0,255)";
		actor.color2 = "rgb(0,255,255)";

		model.enemies[0].color1 = "rgb(0,255,0)";
		model.enemies[0].color2 = "rgb(255,255,0)";

		model.enemies[1].color1 = "rgb(255,0,0)";
		model.enemies[1].color2 = "rgb(255,0,255)";

		if( 2 < model.enemy_max ) {
			model.enemies[2].color1 = "rgb(0,128,0)";
			model.enemies[2].color2 = "rgb(128,128,0)";

			model.enemies[3].color1 = "rgb(128,0,0)";
			model.enemies[3].color2 = "rgb(128,0,128)";
		}
		this.clear();
	}

	,
	clear:function() {
		this.context.clearRect(0, 0, screen_w, screen_h);

		//this.context.fillStyle = "rgb(0,0,0)";
		//this.context.fillRect(0, 0, screen_w, screen_h);
	}

	,
	draw:function() {
		//this.clear();

		this.score.value = model.score;
		//this.debug.value = "draw";

		fr = 2;
		fr2 = fr*2;

		//enemy
		for(i = 0; i < model.enemy_max; i++ ) {
			if( model.enemies[i].status == 0 ) {
				this.drawWorm(model.enemies[i].color1, model.enemies[i].color2,
							  model.enemies[i].x, model.enemies[i].y);
			}
			else {
				this.drawWorm("rgb(128,128,128)", "rgb(64,64,64)",
							  model.enemies[i].x, model.enemies[i].y);
			}
		}

		//actor
		this.drawWorm(actor.color1, actor.color2, actor.x, actor.y);
	}

	,
	drawWorm:function(color1,color2, x,y)
	{
		fr = 2;
		fr2 = fr*2;
		this.context.fillStyle = color1;
		this.context.fillRect(x/qt-box_wh/2, y/qt-box_wh/2, box_wh, box_wh);
		this.context.fillStyle = color2;
		this.context.fillRect(x/qt-box_wh/2+fr, y/qt-box_wh/2+fr, box_wh-fr2, box_wh-fr2);
	}


	, //結果表示
	drawResult:function() {
		this.score.value = model.score;
		//this.debug.value = "draw";

		str = "";
		if( model.result == 0 ) {
			return;
		}
		else if( model.result == 1 ) {
			str = "That's too bad.";
			this.context.fillStyle = "rgb(0,0,0)";
		}
		else /*if( model.result == 2 )*/ {
			str = "You've got it!";
			this.context.fillStyle = "rgb(255,0,0)";
		}

		//metrics = this.context.measureText(str);
		//x = (screen_w - metrics.width) / 2;
		x = screen_w / 3;

		this.context.font = "24px 'sans-serif'";
		
		this.context.fillText(str, x, 30);
	}
}

// user control

function keyCode(e)
{
	if(document.all)
		return e.keyCode;
	if(document.getElementById)
		return (e.keyCode)? e.keyCode: e.charCode;
	if(document.layers)
		return e.which;
	return 0;
}

document.onkeydown = function(e)
{
	view.debug.value = "down";
	try {
		rc = false;
		k = keyCode(e);
		if     ( k == 37 ) keyst.l = true;
		else if( k == 39 ) keyst.r = true;
		else if( k == 38 ) keyst.u = true;
		else if( k == 40 ) keyst.d = true;
		else if( k == 32/*spc*/ ) keyst.b1 = true;
		else if( k == 90/*z*/ ) keyst.b1 = true;
		else if( k == 88/*x*/ ) keyst.b2 = true;
		else if( k == 67/*c*/ ) keyst.b3 = true;
		else if( k == 13/*ent*/ ) keyst.b4 = true;

		else if( 112 <= k && k <= 123 ) rc = true;/*F1-F12*/
	}
	catch(ex) {
		alert(ex);
	}
	return rc;
}

document.onkeyup = function(e)
{
	view.debug.value = "up";
	try {
		rc = false;
		k = keyCode(e);

		if     ( k == 37 ) keyst.l = false;
		else if( k == 39 ) keyst.r = false;
		else if( k == 38 ) keyst.u = false;
		else if( k == 40 ) keyst.d = false;
		else if( k == 32/*spc*/ ) keyst.b1 = false;
		else if( k == 90/*z*/ ) keyst.b1 = false;
		else if( k == 88/*x*/ ) keyst.b2 = false;
		else if( k == 67/*c*/ ) keyst.b3 = false;
		else if( k == 13/*ent*/ ) keyst.b4 = false;

		else if( 112 <= k && k <= 123 ) rc = true;/*F1-F12*/
	}
	catch(ex) {
		alert(ex);
	}
	return rc;
}

document.onkeypress = function(e)
{
	rc = false;
	k = keyCode(e);
	if( 112 <= k && k <= 123 ) rc = true;/*F1-F12*/
	return rc;
}

function btnAOnClick()
{
	view.draw();
}

function btnBOnClick()
{
}

function btnStartOnClick()
{
	model.start();
}

function btnStopOnClick()
{
	model.stop();
}

function btnRestartOnClick()
{
	model.reinit();
	view.clear();
	view.draw();
	model.stop();
	model.start();
}



function initAll()
{
	model.init();
	view.init();
	view.draw();
	model.start();
}

// Local Variables:
// mode:javascript
// tab-width:4
// End:
